<?php

/**
 * Observium
 *
 *   This file is part of Observium.
 *
 * @package    observium
 * @subpackage poller
 * @copyright  (C) 2006-2013 Adam Armstrong, (C) 2013-2016 Observium Limited
 *
 */

$table_defs['NS-ROOT-MIB']['nsSslStatsGroup'] = array (
  'table'     => 'nsSslStatsGroup',
  'mib'       => 'NS-ROOT-MIB',
  'mib_dir'   => 'citrix',
  'file'      => 'netscaler-SslStats.rrd',
  'graphs'    => array('nsSslTransactions'),
  'ds_rename' => array('sslBeTot' => 'Be', 'sslTot' => '', 'ssl' => '', 'Session' => 'Sess', 'Multiplex' => 'Mplx', 'Attempt' => 'Att',
                       'Success' => 'Succ', 'Authentications' => 'Auths', 'Authorizations' => 'Auths', 'Ciphers' => 'Ciphs',
                       'ReNegotiate' => 'ReNeg', 'Exchanges' => 'Exch'),
  'oids'   => array (
    'sslCardStatus'                => array('ds_type' => 'GAUGE'),
    'sslEngineStatus'              => array('ds_type' => 'GAUGE'),
    'sslSessionsPerSec'            => array('ds_type' => 'GAUGE'),
    'sslTotTransactions'            => array(),
    'sslTotSSLv2Transactions'            => array(),
    'sslTotSSLv3Transactions'            => array(),
    'sslTotTLSv1Transactions'            => array(),
    'sslTotSessions'            => array(),
    'sslTotSSLv2Sessions'            => array(),
    'sslTotSSLv3Sessions'            => array(),
    'sslTotTLSv1Sessions'            => array(),
    'sslTotExpiredSessions'            => array(),
    'sslTotNewSessions'            => array(),
    'sslTotSessionHits'            => array(),
    'sslTotSessionMiss'            => array(),
    'sslTotRenegSessions'            => array(),
    'sslTotSSLv3RenegSessions'            => array(),
    'sslTotTLSv1RenegSessions'            => array(),
    'sslTotSSLv2Handshakes'            => array(),
    'sslTotSSLv3Handshakes'            => array(),
    'sslTotTLSv1Handshakes'            => array(),
    'sslTotSSLv2ClientAuthentications'            => array(),
    'sslTotSSLv3ClientAuthentications'            => array(),
    'sslTotTLSv1ClientAuthentications'            => array(),
    'sslTotRSA512keyExchanges'            => array(),
    'sslTotRSA1024keyExchanges'            => array(),
    'sslTotRSA2048keyExchanges'            => array(),
    'sslTotDH512keyExchanges'            => array(),
    'sslTotDH1024keyExchanges'            => array(),
    'sslTotDH2048keyExchanges'            => array(),
    'sslTotRSAAuthorizations'            => array(),
    'sslTotDHAuthorizations'            => array(),
    'sslTotDSSAuthorizations'            => array(),
    'sslTotNULLAuthorizations'            => array(),
    'sslTot40BitRC4Ciphers'            => array(),
    'sslTot56BitRC4Ciphers'            => array(),
    'sslTot64BitRC4Ciphers'            => array(),
    'sslTot128BitRC4Ciphers'            => array(),
    'sslTot40BitDESCiphers'            => array(),
    'sslTot56BitDESCiphers'            => array(),
    'sslTot168Bit3DESCiphers'            => array(),
    'sslTot40BitRC2Ciphers'            => array(),
    'sslTot56BitRC2Ciphers'            => array(),
    'sslTot128BitRC2Ciphers'            => array(),
    'sslTot128BitIDEACiphers'            => array(),
    'sslTotNULLCiphers'            => array(),
    'sslTotMD5Mac'            => array(),
    'sslTotSHAMac'            => array(),
    'sslTotOffloadBulkDES'            => array(),
    'sslTotOffloadRSAKeyExchanges'            => array(),
    'sslTotOffloadDHKeyExchanges'            => array(),
    'sslTotOffloadSignRSA'            => array(),
    'sslBeTotSessions'            => array(),
    'sslBeTotSSLv3Sessions'            => array(),
    'sslBeTotTLSv1Sessions'            => array(),
    'sslBeExpiredSessions'            => array(),
    'sslBeTotSessionMultiplexAttempts'            => array(),
    'sslBeTotSessionMultiplexAttemptSuccess'            => array(),
    'sslBeTotSessionMultiplexAttemptFails'            => array(),
    'sslBeMaxMultiplexedSessions'            => array('ds_type' => 'GAUGE'),
    'sslBeTotSSLv3Handshakes'            => array(),
    'sslBeTotTLSv1Handshakes'            => array(),
    'sslBeTotSSLv3ClientAuthentications'            => array(),
    'sslBeTotTLSv1ClientAuthentications'            => array(),
    'sslBeTotRSA512keyExchanges'            => array(),
    'sslBeTotRSA1024keyExchanges'            => array(),
    'sslBeTotRSA2048keyExchanges'            => array(),
    'sslBeTotDH512keyExchanges'            => array(),
    'sslBeTotDH1024keyExchanges'            => array(),
    'sslBeTotDH2048keyExchanges'            => array(),
    'sslBeTotRSAAuthorizations'            => array(),
    'sslBeTotDHAuthorizations'            => array(),
    'sslBeTotDSSAuthorizations'            => array(),
    'sslBeTotNULLAuthorizations'            => array(),
    'sslBeTot40BitRC4Ciphers'            => array(),
    'sslBeTot56BitRC4Ciphers'            => array(),
    'sslBeTot64BitRC4Ciphers'            => array(),
    'sslBeTot128BitRC4Ciphers'            => array(),
    'sslBeTot40BitDESCiphers'            => array(),
    'sslBeTot56BitDESCiphers'            => array(),
    'sslBeTot168Bit3DESCiphers'            => array(),
    'sslBeTot40BitRC2Ciphers'            => array(),
    'sslBeTot56BitRC2Ciphers'            => array(),
    'sslBeTot128BitRC2Ciphers'            => array(),
    'sslBeTot128BitIDEACiphers'            => array(),
    'sslBeTotNULLCiphers'            => array(),
    'sslBeTotMD5Mac'            => array(),
    'sslBeTotSHAMac'            => array(),
    'sslCurSessions'            => array('ds_type' => 'GAUGE'),
    'sslTotOffloadBulkAES'            => array(),
    'sslTotOffloadBulkRC4'            => array(),
    'sslNumCardsUP'            => array('ds_type' => 'GAUGE'),
    'sslCards'            => array('ds_type' => 'GAUGE'),
    'sslTotBkendSessionReNegotiate'            => array(),
    'sslTotCipherAES128'            => array(),
    'sslTotBkendSslV3Renego'            => array(),
    'sslTotBkendTlSvlRenego'            => array(),
    'sslTotCipherAES256'            => array(),
    'sslTotBkendCipherAES128'            => array(),
    'sslTotBkendCipherAES256'            => array(),
    'sslTotHwEncBE'            => array(),
    'sslTotDec'            => array(),
    'sslTotSwEncFE'            => array(),
    'sslTotEncFE'            => array(),
    'sslTotEnc'            => array(),
    'sslTotDecHw'            => array(),
    'sslTotSwDecBE'            => array(),
    'sslTotHwDecFE'            => array(),
    'sslTotEncHw'            => array(),
    'sslTotDecSw'            => array(),
    'sslTotSwEncBE'            => array(),
    'sslTotEncSw'            => array(),
    'sslTotSwDecFE'            => array(),
    'sslTotEncBE'            => array(),
    'sslTotDecBE'            => array(),
    'sslTotHwDecBE'            => array(),
    'sslTotDecFE'            => array(),
    'sslTotHwEncFE'            => array(),
    'sslTotRSA4096keyExchanges'            => array(),
    'sslCurQSize'            => array('ds_type' => 'GAUGE'),
    'sslChipReinitCount'            => array(),
    'sslTotECDHE224keyExchanges'            => array(),
    'sslTotECDHE256keyExchanges'            => array(),
    'sslTotECDHE384keyExchanges'            => array(),
    'sslTotECDHE521keyExchanges'            => array()
  )
);

